pr def Pension_Contr_APS_total
    args age_R

quietly { 
local FwD = 1/${discount_factor}
local Rir = `FwD'-1
g year_R = year + (`age_R'-edad) 
g edad_r0 = `age_R'-edad  		  
g year_pension0 = (1+death_age-`age_R')
g PW_APS = APS_2019 if year>=2019
replace PW_APS = APS_2008 if year>=2008 & year<=2018
replace PW_APS = APS_2007 if year>=2002 & year<=2007
replace PW_APS = APS_1987 if year>=1975 & year<=2001  //
replace PW_APS = max(APS_2019,APS_2008) if year>=2019 & year_R>=2008 & year_R<=2018
replace PW_APS = max(APS_2019,APS_2008,APS_2007) if year>=2019 & year_R>=2002 & year_R<=2007
replace PW_APS = max(APS_2019,APS_2008,APS_2007,APS_1987) if year>=2019 & year_R>=1975 & year_R<=2001  //
replace PW_APS = max(APS_2008,APS_2007) if year>=2008 & year<=2018 & year_R>=2002 & year_R<=2007
replace PW_APS = max(APS_2008,APS_2007,APS_1987) if year>=2008 & year<=2018 & year_R>=1975 & year_R<=2001   //
replace PW_APS = max(APS_2007,APS_1987) if year>=2002 & year<=2007 & year_R>=1975 & year_R<=2001   //
replace PW_APS = APS_2022 if year>=2022  // PGU
rename PW_APS PW_APS_hh

g PW_APS = APSind_2019 if year>=2019
replace PW_APS = APSind_2008 if year>=2008 & year<=2018
replace PW_APS = APSind_2007 if year>=2002 & year<=2007
replace PW_APS = APSind_1987 if year>=1975 & year<=2001  //
replace PW_APS = max(APSind_2019,APSind_2008) if year>=2019 & year_R>=2008 & year_R<=2018
replace PW_APS = max(APSind_2019,APSind_2008,APSind_2007) if year>=2019 & year_R>=2002 & year_R<=2007
replace PW_APS = max(APSind_2019,APSind_2008,APSind_2007,APSind_1987) if year>=2019 & year_R>=1975 & year_R<=2001  //
replace PW_APS = max(APSind_2008,APSind_2007) if year>=2008 & year<=2018 & year_R>=2002 & year_R<=2007
replace PW_APS = max(APSind_2008,APSind_2007,APSind_1987) if year>=2008 & year<=2018 & year_R>=1975 & year_R<=2001   //
replace PW_APS = max(APSind_2007,APSind_1987) if year>=2002 & year<=2007 & year_R>=1975 & year_R<=2001   //
replace PW_APS = APSind_2022 if year>=2022  // PGU

egen PWind = rowtotal(PW_NoSy PW_APS)
g PWFutind = (`FwD'^edad_r0)*PWind
g m_pension_tot = (`Rir'/(1-`FwD'^(-year_pension0)))*PWFut
bysort folio_hogar: egen m_pension_tot_hh = total(m_pension_tot)   

drop year_R-year_pension0 PWFutind PWind PW_APS APSind_*
}
end
