pr def Pension_PBS_2008
    args age_R

quietly {    
local PBS = 82058   //75000 (2011)  76988 (2012)  82058 (2013)  // quintile_h
local PMAS = 266731  //255000 (2011) 261758 (2012) 266731 (2013)  //local pbs_i = `PBS'/`PMAS' //global pbs_i = 1-0.294   or 1-0.307

g dummyAPS = (m_pension<`PMAS')
g PBS_2008 = dummyAPS*(`PBS'-(`PBS'/`PMAS')*m_pension) if quintile_h<=3

g year_pension0 = (1+death_age-`age_R')
g years_pension = (1- ${discount_factor}^year_pension0)/(1-${discount_factor})
g new_pension = max(0, PBS_2008*years_pension) if Future_retirees==1
replace new_pension = new_pension*(${discount_factor}^(1+`age_R'-min(`age_R',edad)))
bysort folio_hogar: egen APS_2008 = total(new_pension)   //replace APS_2008 = CBeta*max(0, APS_2008) 
g APSind_2008 = new_pension
capture drop dummyAPS-new_pension 
}
end
