local vars_sd "couple_d d_child ocup_female_spouse num_sen dummy_region d_edad2-d_edad8"   // dummy_region or zona2, ytoth taken from 5, 6 and 7
local vars_0 "ytoth_current ytoth `vars_sd'" // Wealth conditional on labor status of the workers (employed, non-employed)
local vars_1 "ytoth_current `vars_sd'"   
local vars_I2 "ln_TotalWI_hh_y `vars_sd'"  // local vars_2 "ln_TotalW_hh_y `vars_sd'"
local vars_I3 "ytoth_current ln_TotalWI_hh_y `vars_sd'"  // local vars_3 "ytoth_current ln_TotalW_hh_y `vars_sd'"
local vars_I4 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PW2I_hh_y `vars_sd'"  // local vars_4 "ytoth_current ln_FE_hh_y ln_PW2_hh_y `vars_sd'"  
local vars_I7 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PW2I_hh_NoSy ln_PW2I_APS_y `vars_sd'"   //local vars_7 "ytoth_current ln_FE_hh_y ln_PW2_hh_NoSy ln_PW2_APS_y `vars_sd'" 
// Exogenous Vars for Saving Rate in Ratios //  unemp_sect ytoth ytoth_current  c.(Rytoth_c)#c.(d_edad2-d_edad8) c.(R_TotalWI_hh)#c.(d_edad2-d_edad8)
local SvarsR_1 "Rytoth_c ytoth  `vars_sd'"  // c.(R_TotalWI_hh)#c.(d_edad2-d_edad8) // c.(R_PW2I_hh)#c.(d_edad2-d_edad8)
local SvarsR_I2 "R_TotalWI_hh `vars_sd'"  // local SvarsR_2 "R_TotalW_hh c.(R_TotalW_hh)#c.(d_edad2-d_edad8) `vars_sd'"   c.(R_PW2I_hh_NoSy R_PW2I_APS)#c.(d_edad2-d_edad8)
local SvarsR_I3 "Rytoth_c ytoth R_TotalWI_hh `vars_sd'"  // local SvarsR_3 "Rytoth_c ytoth_current R_TotalW_hh c.(R_TotalW_hh)#c.(d_edad2-d_edad8) `vars_sd'" 
local SvarsR_I4 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PW2I_hh `vars_sd'"  //local SvarsR_4 "Rytoth_c ytoth_current R_FE_hh R_PW2_hh c.(R_PW2_hh)#c.(d_edad2-d_edad8) `vars_sd'"  
local SvarsR_I7 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PW2I_hh_NoSy R_PW2I_APS `vars_sd'" //local SvarsR_7 "Rytoth_c ytoth_current R_FE_hh R_PW2_hh_NoSy R_PW2_APS `vars_sd'" 
local vars_I8 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PW2I_hh_NoSy ln_PW2I_APS_y `vars_sd' ILFP"  // ILFP ILFP_male_spouse ILFP_female_spouse Female_ILFP Male_ILFP ingreso_trabajo_independiente 
local SvarsR_I8 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PW2I_hh_NoSy R_PW2I_APS `vars_sd' ILFP"  // grupo_edad edad5y educ_ecf educ transferencias arriendo_imputado tenencia_vivienda

//Past wealth: PW_hh_past PWI_hh_past //Future wealth: PW_hh PWI_hh //Sum of past and future wealth: PW2_hh PW2I_hh
local vars_I9 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PWI_hh_past ln_PWI_hh_NoSy ln_PW2I_APS_y `vars_sd' ILFP"  //g PW2_female=max(0,PW_s2_past)+max(0,PW_s2) *g PW2_male=max(0,PW_s1_past)+max(0,PW_s1)
local SvarsR_I9 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PWI_hh_past R_PWI_hh_NoSy R_PW2I_APS `vars_sd' ILFP"  // PW_hh_past PW_hh *g PW2_hh=max(0,PW_hh_past)+max(0,PW_hh) 

local BetaVars "BetaPF_unemployed BetaPF_sd_ln_ing_tot_ocup3 Beta_unemployed Beta_sd_ln_ing_tot_ocup3"
local vars_I10 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PWI_hh_past ln_PWI_hh_NoSy ln_PW2I_APS_y `vars_sd' ILFP `BetaVars'" 
local SvarsR_I10 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PWI_hh_past R_PWI_hh_NoSy R_PW2I_APS `vars_sd' ILFP `BetaVars'" 
local vars_I11 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PW2I_hh_NoSy ln_PW2I_APS_y `vars_sd' `BetaVars'" 
local SvarsR_I11 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PW2I_hh_NoSy R_PW2I_APS `vars_sd' `BetaVars'" 
local BetaVars2 "BetaPF_sd_ln_ing_tot_ocup3 Beta_sd_ln_ing_tot_ocup3"
local vars_I12 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PWI_hh_past ln_PWI_hh_NoSy ln_PW2I_APS_y `vars_sd' ILFP `BetaVars2'" 
local SvarsR_I12 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PWI_hh_past R_PWI_hh_NoSy R_PW2I_APS `vars_sd' ILFP `BetaVars2'" 
local vars_I13 "ytoth_current ln_FE_hh_y ln_FENL_hh_y ln_PW2I_hh_NoSy ln_PW2I_APS_y `vars_sd' `BetaVars2'" 
local SvarsR_I13 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh R_FENL_hh R_PW2I_hh_NoSy R_PW2I_APS `vars_sd' `BetaVars2'" 

local FENLVars "ln_FErent ln_FEtransfers ln_FEfinassets"
local FENLVars2 "R_FErent R_FEtransfers R_FEfinassets"
local vars_I14 "ytoth_current ln_FE_hh_y `FENLVars' ln_PWI_hh_past ln_PWI_hh_NoSy ln_PW2I_APS_y `vars_sd' ILFP `BetaVars'" 
local SvarsR_I14 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh `FENLVars2' R_PWI_hh_past R_PWI_hh_NoSy R_PW2I_APS `vars_sd' ILFP `BetaVars'" 
local vars_I15 "ytoth_current ln_FE_hh_y `FENLVars' ln_PWI_hh_past ln_PWI_hh_NoSy ln_PW2I_APS_y `vars_sd' ILFP" 
local SvarsR_I15 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh `FENLVars2' R_PWI_hh_past R_PWI_hh_NoSy R_PW2I_APS `vars_sd' ILFP" 
local vars_I16 "ytoth_current ln_FE_hh_y `FENLVars' ln_PW2I_hh_NoSy ln_PW2I_APS_y `vars_sd'" 
local SvarsR_I16 "sd_ln_inc_sect Rytoth_c ytoth R_FE_hh `FENLVars2' R_PW2I_hh_NoSy R_PW2I_APS `vars_sd'" 

capture log close  //local sop1="replace"  //local sop2="append"    //local ovars "R_TotalWI_hh R_PW2I_hh R_PW2I_hh_NoSy R_PW2I_APS"
set more off

use "$path4b\expenditures_${data_save_emp}_all4.dta", clear  // use "$path4b\expenditures_${data_save_emp}_all.dta", clear  
sum PW_hh PW2_hh PWI_hh PW2I_hh		//		//		//		//		//		//
foreach num of numlist 2017 2012 1997 { // New Vars
joinby folio_hogar year using "$path4b\PensionScen_`num'.dta", unmatched(master) update
tab _merge
drop _merge
}
tab a1
egen FErent = rowtotal(yai yaotp)   // Separate Non-Labor Earnings (FENL_hh) into housing (FErent), transfers (FEtransfers) and financial assets income (FEfinassets)
replace FErent = DS_FS2*max(0,FErent)
g FEtransfers = DS_FS2*max(0,transferencias)
g FEfinassets = DS_FS2*max(0,yact)
foreach x in FErent FEtransfers FEfinassets { 
replace `x' = max(0,`x'/YLaborI)
g `x'_y = CBeta*`x'*YLaborI //either exp(ytoth) or YLaborI // Multiply ratio by Labor Income and by the theoretical marginal propensity to consume out of wealth
g ln_`x'_y = ln(`x'_y)
}
tab ILFP2 ILFP
sum ILFP2 ILFP
replace ILFP=max(0,ILFP,ILFP2)
sum ILFP2 ILFP
replace CBeta = (1-${discount_factor})/(1-${discount_factor}^(1+max(life_expectancy0,edad)-edad)) //if edad>=25 & edad<=life_expectancy0
replace ln_TotalWI_hh_y  = max(0, ln(CBeta*B0_TW_hh) )      // replace old measures with re-computed B0 vars: TW_hh PW_hh PW_NoSy_hh PW_APS_hh FE_hh
replace ln_PW2I_hh_y = max(0, ln(CBeta*B0_PW_hh) ) 
replace ln_PW2I_hh_NoSy = max(0, ln(CBeta*B0_PW_NoSy_hh) ) 
replace ln_PW2I_APS_y = max(0, ln(CBeta*B0_PW_APS_hh) ) 
replace ln_FE_hh_y = max(0, ln(CBeta*B0_FE_hh) )       //     End of new vars      //   
g dummy_region = (zona2==1)
tab zona2 dummy_region
tab zona2 dummy_region if year<2007
keep if year>=${Ewave}   // 2017 preferrable //2008   // remember No Pilar Solidario before 2008
egen lnY = rowmax(ytoth ytoth_curr ytoth_pi ytoth_cons)   
egen Yl = rowmax(ytoth_pi_vs0 ytoth2 ytot_p_h ytoth_pi_exp)  
replace Yl = max(Yl, exp(lnY))   
replace ytoth=exp(ytoth)
replace ytoth_curr=exp(ytoth_curr)
pwcorr Yl ytoth_curr ytoth ytoth_pi ytoth_cons ytoth_pi_vs0 ytoth2 ytot_p_h ytoth_pi_exp  // Basically permanent income (ytoth)
replace ytoth=ln(ytoth)
replace ytoth_curr=ln(ytoth_curr)
g YPm = min( exp(ytoth), ytoth_pi_vs0)  
replace YPm = min(YPm,exp(ytoth_pi),ytoth2) if year==2017   // ytot_p_h
replace YPm = (YPm+exp(ytoth_pi))/2 if year<2017    // (YPm+exp(ytoth_pi)+ytoth2)/3
sum Yl ytoth_curr ytoth ytoth_pi ytoth_cons ytoth_pi_vs0 ytoth2 ytot_p_h ytoth_pi_exp
g SRate = (exp(ytoth_current)-exp(gasto_tot))/Yl   // g SRate = (exp(ytoth)-exp(gasto_tot))/Yl   
sum SRate, d
replace SRate= min(r(p95), max(r(p5),SRate) ) if SRate<.
g SRatePI = (YPm-exp(gasto_tot))/Yl       // (exp(ytoth)-exp(gasto_tot))/Yl 
sum SRatePI, d
replace SRatePI= min(r(p95), max(r(p5),SRatePI) ) if SRatePI<.
sum SRate SRatePI if year==2017, d
g Rytoth_c=(exp(ytoth_current)-Yl)/Yl    // (exp(ytoth_current)-Yl)/Yl   //(exp(ytoth_current)-YPm)/Yl
g CRate = exp(gasto_tot)/Yl   // g SRate = (exp(ytoth)-exp(gasto_tot))/Yl   
sum CRate, d
replace CRate= min(r(p95), max(r(p5),CRate) ) if CRate<.
tab year
tab a1
quietly {  
local Ln_W = "ln_TotalW_hh_y ln_PW2_hh_y ln_TotalWI_hh_y ln_PW2I_hh_y ln_FE_hh_y ln_PW2_hh_NoSy ln_PW2_APS_y ln_PW2I_hh_NoSy ln_PW2I_APS_y"
local Ln_W2 = "ln_PW_hh_past_y ln_PWI_hh_past_y ln_PW_hh_NoSy ln_PWI_hh_NoSy"
local Ln_W3 = "ln_FENL_hh_y ln_FErent ln_FEtransfers ln_FEfinassets"
foreach x in `Ln_W' `Ln_W2' `Ln_W3' { 
local x2 = regexr( substr("`x'", 4,.), "_y", "")
g R_`x2' = max(0, exp(`x'))/Yl   //g OR`x'=`x'   g ORR_`x2' = R_`x2' 
}
}
sum ytoth_current ytoth if a1==1 [fw=${factor_op}], d
pwcorr ytoth_current ytoth ln_TotalW_hh_y ln_FE_hh_y ln_FENL_hh_y ln_PW2_hh_y if a1==1 
sum sexo educ zona2 sector_ind grupo_edad2 quintile_h
joinby sexo educ zona2 sector_ind tr_edad2 quintile_h using "$path_epf_TS\BetaPF_WageVol_LaborFlows.dta", unmatched(master) update
tab _merge
drop _merge
joinby sexo educ zona2 sector_ind tr_edad2 quintile_h using "$path_epf_TS\Beta_WageVol_LaborFlows.dta", unmatched(master) update
tab _merge
drop _merge
sum Beta*
quietly {  
foreach x of varlist Beta* {
replace `x' = 0 if `x'==.
} 
} 
sum Beta*
pwcorr Beta*
local other_vars "PCSLabEhh income_male_spouse income_female_spouse Female_LFP Male_LFP ILFP ILFP2 Female_ILFP Male_ILFP numh desem2 ytoth ytoth_current YLaborI"
local other_vars2 "dummy_durable ln_* CBeta zona2 num_adul num_men num_sen grupo_edad2 zona2 EI_hh FE_hh PW_hh PW_hh_past PW2_hh TotalW_hh FENL_hh DS_FS2"
local other_vars3 "ytot_p_h ytoth_pi_exp sector_ind ytoth_cons yai yaotp yact transferencias sexo tr_edad2 educ edad folio_hogar year quarte quintile_h"
local other_vars4 "age_male_spouse age_female_spouse female_spouse_dummy male_spouse_dummy spouse_partner_hhead2 male_dum female_dum ytot_ind3 ytot_ind4"
local other_vars5 "SRate lnY Yl YPm R_* Rytoth_c SRatePI CRate CBeta B0_PW_NoSy-S7_Impuestos4 FErent FEtransfers FEfinassets "
local vars1 "*m_pension* LabE PCS* *educ* *life* death* ytoth_current ln_TotalW_hh_y sd_ln_inc_sect pr_unemp unemp_sect `vars_sd' dummy_region"
drop pr_unemp_* 
egen id = group(sexo educ zona2 sector_ind grupo_edad2 year)  // quintile_h 
keep ${factor_op} id ho* gasto_* `vars1' `vars2' *sect `other_vars' `other_vars2' `other_vars3' `other_vars4' `other_vars5' `BetaVars' `FENLVars' //OR* ORR_*
capture rename PW_hh PW00_hh 
g vs0_PW_NoSy_past_hh = R_PWI_hh_past
g vs0_PW_NoSy_future_hh = R_PWI_hh_NoSy
g constant = 1
g OR_ytoth_current = ytoth_current
g OR_ytoth = ytoth
g OR_Yl =  Yl
g uf_q4 = 13956.1	if year==1997
replace uf_q4 = 19433.5	if year==2007
replace uf_q4 = 22783.5	if year==2012
replace uf_q4 = 26798	if year==2017

// Spending regressions
reg gasto_tot `vars_1', vce(robust)   // i.(year) [pw=${factor_op}]
outreg2 using "$path_g3\\Rtot_ols.xls", replace  //matrix bc0 = e(b)'  svmat double bc0, name(ols_tot_all)
foreach Vk of numlist 2 3 4 7 8 9 10 11 12 13 14 15 16 {  
reg gasto_tot `vars_I`Vk'', vce(robust)
outreg2 using "$path_g3\\Rtot_ols.xls", append
}         
//   //

// Saving Rates regressions and + use regresions  to simulate Policy changes: +6% (with 0%, 1%, 2%, 3% for Pilar Solidario)
local SRate1 = "SRate"
local SRate2 = "SRatePI"  //local SRate3 = "CRate"
foreach Yv of numlist 1 2 {  //1 2 3  local Vkvars = "`vars_`Vk''"
if `Yv'==2 { 
replace Rytoth_c=(exp(ytoth_current)-YPm)/Yl   
} 
local SR = "`SRate`Yv''"
reg `SR' `vars_1' , vce(robust)   
outreg2 using "$path_g3\\`SR'_ols.xls", replace  
foreach Vk of numlist 2 3 4 7 8 9 10 11 12 13 14 15 16 {  
reg `SR' `vars_I`Vk'', vce(robust)
outreg2 using "$path_g3\\`SR'_ols.xls", append
}     
// Saving Rates regressions with Ratios
reg `SR' `SvarsR_1' , vce(robust)   
outreg2 using "$path_g3\\`SR'R2_ols.xls", replace  
predictLS_old_new1 e`SR'_m1
foreach Vk of numlist 2 3 4 7 8 9 10 11 12 13 14 15 16 {  
reg `SR' `SvarsR_I`Vk'', vce(robust)
outreg2 using "$path_g3\\`SR'R2_ols.xls", append
predictLS_old_new1 e`SR'_m`Vk'
}  
// Saving Rates regressions with Ratios (clustered STD)
reg `SR' `SvarsR_1', vce(cluster id)   
outreg2 using "$path_g3\\`SR'R2_ols_clusterSTD.xls", replace  
foreach Vk of numlist 2 3 4 7 8 9 10 11 12 13 14 15 16 {  
reg `SR' `SvarsR_I`Vk'', vce(cluster id)
outreg2 using "$path_g3\\`SR'R2_ols_clusterSTD.xls", append
}  
}
save "$path4b\SRates_allScen.dta", replace
