local SRate1 = "SRate"     // quintile_h educ_ecf  PCSI_hh  PCS PCSemp gasto_total numh
local SRate2 = "SRatePI"  //local SRate3 = "CRate" //gasto_tot

local W1="constant"
local W2="LabE"
local Edv="educ_ecf"  // educ_ecf educ educ_yr educ_yr2
quietly {
local RRvars "`SRate1' `SRate2' agg`SRate1' agg`SRate2' LR_TotalWI_hh LR_FE_hh LR_FENL_hh LR_PW2I_hh_NoSy LR_PW2I_APS LR_FErent LR_FEtransfers LR_FEfinassets CBeta R_TotalWI_hh R_FE_hh R_PW2I_hh_NoSy R_PW2I_APS"
local RRvars2 "R_FENL_hh R_PWI_hh_past R_PWI_hh_NoSy R_FErent R_FEtransfers R_FEfinassets"
local Dvars  "ytoth sd_ln_inc_sect pr_unemp unemp_sect PCS PCSemp EDUCd* couple_d d_child ocup_female_spouse num_sen ILFP" 
use "$path4b\SRates_allScen.dta", clear     //xpose, clear varname   // reshape long A_ SEmSt_, i(constant) j(Portfolio) string //
replace R_TotalWI_hh = R_TotalWI_hh + max(0,R_FENL_hh)
g agg`SRate1' =  `SRate1' + max(0, ${pcrate}*PCSLabEhh/Yl) 
g agg`SRate2' =  `SRate2' + max(0, ${pcrate}*PCSLabEhh/Yl) 
tab `Edv', gen(EDUCd)
foreach x of varlist R_TotalWI_hh R_FE_hh R_PW2I_hh_NoSy R_PW2I_APS R_FENL_hh R_PWI_hh_past R_PWI_hh_NoSy R_FErent R_FEtransfers R_FEfinassets { 
g L`x' = `x'/CBeta 
}
collapse `RRvars' `RRvars2' `Dvars' [fw=${factor_op}]
xpose, clear varname
rename v1 v0
save "$path4b\data_temp.dta", replace

use "$path4b\SRates_allScen.dta", clear     //xpose, clear varname   // reshape long A_ SEmSt_, i(constant) j(Portfolio) string //
replace R_TotalWI_hh = R_TotalWI_hh + max(0,R_FENL_hh)
g agg`SRate1' =  `SRate1' + max(0, ${pcrate}*PCSLabEhh/Yl) 
g agg`SRate2' =  `SRate2' + max(0, ${pcrate}*PCSLabEhh/Yl) 
foreach x in R_TotalWI_hh R_FE_hh R_PW2I_hh_NoSy R_PW2I_APS R_FENL_hh R_PWI_hh_past R_PWI_hh_NoSy R_FErent R_FEtransfers R_FEfinassets { 
g L`x' = `x'/CBeta 
}
tab `Edv', gen(EDUCd)
g Grupo_edad = grupo_edad2
recode Grupo_edad 2/3=2 4/5=3 6/7=4 8=5
collapse `RRvars' `RRvars2' `Dvars' [fw=${factor_op}], by(Grupo_edad)  // Grupo_edad grupo_edad2
xpose, clear varname
joinby _varname using "$path4b\data_temp.dta", unmatched(both) update
tab _merge
order v0, first
drop _merge
export excel using "$path_g1\\EPF2017_pop25_64Vars.xlsx", firstrow(variables) nolabel replace
}  
// 		//      //   Elementary education, Secondary education, Technical or Some college, College education, Post-graduate education

use "$path4b\SRates_allScen.dta", clear     //xpose, clear varname   // reshape long A_ SEmSt_, i(constant) j(Portfolio) string //
g Grupo_edad = grupo_edad2
recode Grupo_edad 2/3=2 4/5=3 6/7=4 8=5
g pop=1
bysort Grupo_edad: egen N = count(constant)
collapse (mean) N (sum) pop [fw=${factor_op}], by(Grupo_edad)
save "$path4b\data_temp.dta", replace
use "$path4b\SRates_allScen.dta", clear 
g pop=1
egen N = count(constant)
collapse (mean) N (sum) pop [fw=${factor_op}]
g Grupo_edad = 0
joinby Grupo_edad using "$path4b\data_temp.dta", unmatched(both) update
tab _merge
drop _merge
xpose, clear varname
foreach x of varlist v2-v6 { 
replace `x' = `x'/v1 if _varname=="pop"
}
export excel using "$path_g1\\EPF2017_N25_64.xlsx", firstrow(variables) nolabel replace
