capture drop income_male_spouse_pot income_female_spouse_pot
capture drop y_ind_pot1 y_ind_pot2
g income_male_spouse_pot = income_male_spouse if Male_LFP==1
g income_female_spouse_pot = income_female_spouse if Female_LFP==1
bysort year sexo zona2 grupo_edad educ: egen y_ind_pot1 = pctile(income_male_spouse_pot), p(30)    //median(income_male_spouse_pot) 
bysort year sexo zona2 grupo_edad educ: egen y_ind_pot2 = pctile(income_female_spouse_pot), p(30)  //median(income_female_spouse_pot) 
foreach x in y_ind_pot1 y_ind_pot2 {
sum `x' if  `x'>0, d
replace `x' = max( r(p5),  `x' ) if `x'<.  //replace `x' = min( r(p95),  `x' ) if `x'<.
}
replace income_male_spouse_pot = max(income_male_spouse, income_male_spouse_pot,y_ind_pot1) if Male_LFP==0 
replace income_female_spouse_pot = max(income_female_spouse, income_female_spouse_pot,y_ind_pot2) if Female_LFP==0 
foreach x in income_male_spouse_pot income_female_spouse_pot {
sum `x' if  `x'>0, d
replace `x' = max( r(p5),  `x' ) if `x'<.  //replace `x' = min( r(p95),  `x' ) if `x'<.
}
//
