pr def Ingreso_bruto
    args var_inc option new
// option 0 - no dropping of variables, >=1: keeps only monthly tax paid
quietly {  // Income Brackets for Personal Tax (Annual)
local tramo0 = 0        // 0 - 6513372 : 0%
local tramo1 = 6513372  // 6513372 - 14474160 : 5%
local tramo2 = 14474160  // 14474160 - 24123600: 10%
local tramo3 = 24123600  // 24123600 - 33773040: 15%
local tramo4 = 33773040  // 33773040 - 43422480: 25%
local tramo5 = 43422480  // 43422480 - 57896640: 32%
local tramo6 = 57896640  // 57896640 - 72370800: 37%
local tramo7 = 72370800  // > 72370800: 40%
local tramo8 = 7237080000
local tax0 = 0
local tax1 = 0.00
local tax2 = 0.05
local tax3 = 0.10
local tax4 = 0.15
local tax5 = 0.25
local tax6 = 0.32
local tax7 = 0.37
local tax8 = 0.40

g tax_paid = 0  // Tax paid by individual person in pesos
g temp_inc0=  12*`var_inc' if  `var_inc'>0 & `var_inc'<. 
g tax_bracket = 1
foreach k of numlist 8 7 6 5 4 3 2 1 {
forv k1 = 1/`k' {
local k0 = `k1'-1
replace tax_paid = tax_paid + max(0, min( (temp_inc0-`tramo`k0'')*`tax`k1'', (`tramo`k1''-`tramo`k0'')*`tax`k1'') ) if temp_inc0>0 & temp_inc0<. 
}
local k0 = `k'-1
replace tax_bracket = `k' if temp_inc0>`tramo`k0'' & tax_bracket==1
}
replace tax_paid = tax_paid/12  // Tax is now calculated as monthly value
drop temp_inc0
if `option'>=1  {
drop tax_bracket
}
rename tax_paid `var_inc'_mtax // monthly tax
}
// 

end
