// Male Tope
foreach nx in "male" "female" {
quietly {
g edad_tope_`nx' = 25 + ceil( (49-25)*(${tope_2013}-ylabor_`nx'_min)/(ylabor_`nx'_max-ylabor_`nx'_min) ) if a1==1 & `nx'_dummy==1
replace edad_tope_`nx' = max(edad_tope_`nx',25) if edad_tope_`nx'<.
replace edad_tope_`nx' = . if edad_tope_`nx'>=50
g tope_`nx'_cur0 = max(1, income_`nx'_spouse_pot/${tope_2013} ) if a1==1 & `nx'_dummy==1
g tope_`nx'_min = max(1, ylabor_`nx'_min/${tope_2013} )  if a1==1 & `nx'_dummy==1
g tope_`nx'_max = max(1, ylabor_`nx'_max/${tope_2013} )  if a1==1 & `nx'_dummy==1
g tope_`nx'_cur = max(1, (tope_`nx'_min+tope_`nx'_cur0)/2) if a1==1 & `nx'_dummy==1
g tope_`nx'_fut = max(1, (tope_`nx'_max+tope_`nx'_cur0)/2) if a1==1 & `nx'_dummy==1

g w1 = (1- ${discount_factor}^(1+edad_tope_`nx'-25))
g w2 = (1- ${discount_factor}^(1+49-edad_tope_`nx'))
g w3 = (1- ${discount_factor}^(1+${age_retirement}-49))
g w10 = (1- ${discount_factor}^(1+edad-25))
g w11 = (1- ${discount_factor}^(1+edad_tope_`nx'-edad))
g w21 = (1- ${discount_factor}^(1+edad-edad_tope_`nx'))
g w22 = (1- ${discount_factor}^(1+49-edad))
g w31 = (1- ${discount_factor}^(1+edad-49))
g w32 = (1- ${discount_factor}^(1+${age_retirement}-edad))

g w00 = w1+w21
g tope_`nx'_pwpast = 1 if edad_tope_`nx'==. & a1==1 & `nx'_dummy==1
replace tope_`nx'_pwpast = 1  if edad<edad_tope_`nx' & edad<. & a1==1 & `nx'_dummy==1
replace tope_`nx'_pwpast = (w1/w00)*1 + (w21/w00)*tope_`nx'_cur  if edad<50 & a1==1 & `nx'_dummy==1 & tope_`nx'_pwpast==.
replace w00 = w1+w2+w31
replace tope_`nx'_pwpast = (w1/w00)*1 + (w2/w00)*tope_`nx'_cur + (w31/w00)*tope_`nx'_max if edad>=50 & edad<. & a1==1 & `nx'_dummy==1 & tope_`nx'_pwpast==.

g tope_`nx'_pw = 1 if edad_tope_`nx'==. & a1==1 & `nx'_dummy==1
replace tope_`nx'_pw = tope_`nx'_max  if edad>=50 & edad<. & a1==1 & `nx'_dummy==1 & tope_`nx'_pw==.
replace w00 = w11+w22+w3
replace tope_`nx'_pw = (w11/w00)*1 + (w22/w00)*tope_`nx'_fut  + (w3/w00)*tope_`nx'_max if edad<edad_tope_`nx' & edad<50 & a1==1 & `nx'_dummy==1 & tope_`nx'_pw==.
replace w00 = w22+w3
replace tope_`nx'_pw = (w22/w00)*tope_`nx'_fut  + (w3/w00)*tope_`nx'_max  if edad>=edad_tope_`nx' & edad<50 & a1==1 & `nx'_dummy==1 & tope_`nx'_pw==.

replace w00 = w10+w32
g tope_`nx'_pw2 = (w10/w00)*tope_`nx'_pwpast + (w32/w00)*tope_`nx'_pw
drop w00 w1 w2 w3 w10 w11 w21 w22 w31 w32 tope_`nx'_cur0 tope_`nx'_cur tope_`nx'_min tope_`nx'_max tope_`nx'_fut
}
sum edad_tope_`nx', d  // income_`nx'_spouse_pot income_fe`nx'_spouse_pot
sum edad_tope_`nx' if edad_tope_`nx'==25
sum ylabor_`nx'_max tope_`nx'_* if ylabor_`nx'_max>${tope_2013}, d //tope_`nx'_max>1 & 
}
g tope_hh_pwpast = max(1, max(1,tope_male_pwpast)*Male_sh + max(1,tope_female_pwpast)*(1-Male_sh) )
g tope_hh_pw = max(1, max(1,tope_male_pw)*Male_sh + max(1,tope_female_pw)*(1-Male_sh) )
g tope_hh_pw2 = max(1, max(1,tope_male_pw2)*Male_sh + max(1,tope_female_pw2)*(1-Male_sh) )
foreach nx in "male" "female" "hh" {
foreach x of varlist PW_`nx'_past PWI_`nx'_past { 
replace `x' = `x'/max(1,tope_`nx'_pwpast)
}
foreach x of varlist PW_`nx' PWI_`nx' { 
replace `x' = `x'/max(1,tope_`nx'_pw)
}
foreach x of varlist PW2_`nx' PW2I_`nx' { 
replace `x' = `x'/max(1,tope_`nx'_pw2)
}
}
//  
