pr def predictLS_old_new1
    args new_var

quietly { 	// also change R_PWI_hh_past R_PWI_hh_NoSy
predict B0_`new_var', xb     // Baseline (2018): "R_TotalWI_hh R_PW2I_hh R_PW2I_hh_NoSy R_PW2I_APS"
replace R_PWI_hh_past = CBeta*max(0,B_PW_NoSy_past_hh)/Yl
replace R_PWI_hh_NoSy= CBeta*max(0,B_PW_NoSy_future_hh)/Yl
replace R_PW2I_APS = CBeta*max(0,B_PW_APS_hh)/Yl
replace R_PW2I_hh_NoSy = CBeta*max(0,B_PW_NoSy_hh)/Yl
replace R_PW2I_hh = CBeta*max(0,B_PW_hh)/Yl
replace R_TotalWI_hh = CBeta*max(0,B_TW_hh)/Yl
replace R_FE_hh = CBeta*max(0,B_FE_hh)/Yl
predict B_`new_var', xb     // Baseline with new Pilar Solidario of 2019-2022 plus Retiros AFP of 2020 and 2021

replace ytoth_current = ln( 0.94*exp(OR_ytoth_current) )
replace ytoth = ln( 0.94*exp(OR_ytoth) )
replace Yl = 0.94*OR_Yl
forv s=1/7 {   // S scenarios      
replace R_PWI_hh_past = CBeta*max(0,S`s'_PW_NoSy_past_hh)/Yl
replace R_PWI_hh_NoSy= CBeta*max(0,S`s'_PW_NoSy_future_hh)/Yl
replace R_PW2I_APS = CBeta*max(0,S`s'_PW_APS_hh)/Yl
replace R_PW2I_hh_NoSy = CBeta*max(0,S`s'_PW_NoSy_hh)/Yl
replace R_PW2I_hh = CBeta*max(0,S`s'_PW_hh)/Yl
replace R_TotalWI_hh = CBeta*max(0,S`s'_TW_hh)/Yl
replace R_FE_hh = CBeta*max(0,S`s'_FE_hh)/Yl
predict S`s'_`new_var', xb  
if `s'>=3 {   // Scenarios with Reparto
forv op = 1/4 {
egen PW_APS_hh = rowtotal(S`s'_PW_APS_hh S`s'_APS_Reparto`op')
egen PW_hh = rowtotal(S`s'_PW_NoSy_hh PW_APS_hh)
egen TW_hh = rowtotal(S`s'_FE_hh PW_hh)
replace R_PW2I_APS = CBeta*max(0,PW_APS_hh)/Yl   //replace R_PW2I_hh_NoSy = CBeta*max(0,S`s'_PW_NoSy_hh)/Yl
replace R_PW2I_hh = CBeta*max(0,PW_hh)/Yl
replace R_TotalWI_hh = CBeta*max(0,TW_hh)/Yl
predict S`s'Rep`op'_`new_var', xb  
drop PW_APS_hh PW_hh TW_hh
}
}
}
replace ytoth_current=OR_ytoth_current 
replace ytoth=OR_ytoth
replace Yl=OR_Yl 
replace R_PWI_hh_past = vs0_PW_NoSy_past_hh    // CBeta*max(0,B0_PW_NoSy_past_hh)/Yl
replace R_PWI_hh_NoSy= vs0_PW_NoSy_future_hh   // CBeta*max(0,B0_PW_NoSy_future_hh)/Yl
replace R_PW2I_APS = CBeta*max(0,B0_PW_APS_hh)/Yl
replace R_PW2I_hh_NoSy = CBeta*max(0,B0_PW_NoSy_hh)/Yl
replace R_PW2I_hh = CBeta*max(0,B0_PW_hh)/Yl
replace R_TotalWI_hh = CBeta*max(0,B0_TW_hh)/Yl
replace R_FE_hh = CBeta*max(0,B0_FE_hh)/Yl
}
//    //
 
end
